(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('vue-class-component')) :
    typeof define === 'function' && define.amd ? define(['exports', 'vue-class-component'], factory) :
    (global = global || self, factory(global.VueApolloDecorators = {}, global.VueClassComponent));
}(this, (function (exports, vueClassComponent) { 'use strict';

    function extend(target) {
        var sources = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            sources[_i - 1] = arguments[_i];
        }
        for (var i = 0; i < sources.length; i++)
            for (var key in sources[i])
                if (Object.prototype.hasOwnProperty.call(sources[i], key))
                    target[key] = sources[i][key];
        return target;
    }
    function merge(target) {
        var sources = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            sources[_i - 1] = arguments[_i];
        }
        for (var i = 0; i < sources.length; i++)
            target.concat(sources[i]);
        return target;
    }

    function SmartQuery(options) {
        return vueClassComponent.createDecorator(function (componentOptions, key) {
            var _a;
            componentOptions.apollo = extend(componentOptions.apollo || {}, (_a = {},
                _a[key] = extend(componentOptions.apollo[key] || {}, options && options.query ? options : {
                    query: options,
                }),
                _a));
        });
    }

    function SubscribeToMore(options) {
        return vueClassComponent.createDecorator(function (componentOptions, key) {
            var _a;
            componentOptions.apollo = extend(componentOptions.apollo || {}, (_a = {},
                _a[key] = extend(componentOptions.apollo[key] || {}, {
                    subscribeToMore: merge([], componentOptions.apollo[key].subscribeToMore || [], options),
                }),
                _a));
        });
    }

    exports.SmartQuery = SmartQuery;
    exports.SubscribeToMore = SubscribeToMore;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.umd.js.map
